/* draw.c */

/* Darrell R. Hougen, February 9, 1995. */

/* This function draws rectangles on an image. */

#include <rsta_types.h>
#include <viff.h>
#include <stdio.h>

void draw_rectangles(struct xvimage     *image,
		     detection_desc_t   *detects,
		     int                 num_detects,
		     int                 verbose)
{
  int i, j, x, y, x0, y0, x1, y1, w, h, n;
  unsigned char *data, *dp;

  if (verbose)
    printf("Drawing rectangles\n");

  w = image->row_size;
  h = image->col_size;
  n = w * h;
  for (i = 0; i < num_detects; i++)
    {
      data = (unsigned char *)image->imagedata;
      x0 = detects[i].CCD_loc.x;
      y0 = detects[i].CCD_loc.y;
      x1 = x0 + detects[i].CCD_size.x - 1;
      y1 = y0 + detects[i].CCD_size.y - 1;
      for (j = 0; j < 3; j++)
	{
	  dp = data + y0 * w + x0;
	  for (x = x0; x <= x1; x++, dp++)
	    *dp = 255;
	  dp = data + y1 * w + x0;
	  for (x = x0; x <= x1; x++, dp++)
	    *dp = 255;
	  dp = data + y0 * w + x0;
	  for (y = y0; y <= y1; y++, dp += w)
	    *dp = 255;
	  dp = data + y0 * w + x1;
	  for (y = y0; y <= y1; y++, dp += w)
	    *dp = 255;
	  data += n;
	}
    }
}
